Index: /src/map/skill.c
===================================================================
--- /src/map/skill.c (revision 13)
+++ /src/map/skill.c (revision 19)
@@ -42,5 +42,5 @@
 #define GD_SKILLRANGEMIN 900
 #define GD_SKILLRANGEMAX GD_SKILLRANGEMIN+MAX_GUILDSKILL
-#define HM_SKILLRANGEMIN 1100 //Custom Jobs (blackmagic)//Custom Job End
+#define HM_SKILLRANGEMIN 1100
 #define HM_SKILLRANGEMAX HM_SKILLRANGEMIN+MAX_HOMUNSKILL
 
@@ -283,5 +283,5 @@
 	struct status_change* sc;
 	sc = status_get_sc(bl);
-	
+
 	// Never copy NPC/Wedding Skills
 	if (skill_get_inf2(skillid)&(INF2_NPC_SKILL|INF2_WEDDING_SKILL))
@@ -300,5 +300,5 @@
 	if ((skillid == AL_INCAGI || skillid == AL_BLESSING))
 		return 0;
-		
+
 	return 1;
 }
@@ -306,13 +306,13 @@
 // [MouseJstr] - skill ok to cast? and when?
 int skillnotok (int skillid, struct map_session_data *sd)
-{	
+{
 	int i,m;
 	nullpo_retr (1, sd);
 	m = sd->bl.m;
 	i = skill_get_index(skillid);
-	
+
 	if (i == 0)
 		return 1; // invalid skill id
-	
+
 	if (battle_config.gm_skilluncond && pc_isGM(sd) >= battle_config.gm_skilluncond)
 		return 0;  // GMs can do any damn thing they want
@@ -354,5 +354,5 @@
 				return 1;
 			}
-			break;	
+			break;
 		case MC_VENDING:
 		case MC_IDENTIFY:
@@ -387,5 +387,5 @@
 	if (i == 0)
 		return 1; // invalid skill id
-	
+
 	if (hd->blockskill[i] > 0)
 		return 1;
@@ -396,5 +396,5 @@
 
 struct s_skill_unit_layout* skill_get_unit_layout (int skillid, int skilllv, struct block_list* src, int x, int y)
-{	
+{
 	int pos = skill_get_unit_layout_type(skillid,skilllv);
 	int dir;
@@ -420,5 +420,5 @@
 
 /*==========================================
- * 
+ *
  *------------------------------------------*/
 int skill_additional_effect (struct block_list* src, struct block_list *bl, int skillid, int skilllv, int attack_type, unsigned int tick)
@@ -450,5 +450,5 @@
 	if (!tsc) //skill additional effect is about adding effects to the target...
 		//So if the target can't be inflicted with statuses, this is pointless.
-		return 0;	
+		return 0;
 
 	switch(skillid)
@@ -482,5 +482,5 @@
 						(2000 - 4*sstatus->agi - 2*sstatus->dex)))
 					; //Stance triggered
-				else if(sc->data[SC_READYTURN] && 
+				else if(sc->data[SC_READYTURN] &&
 					sc_start(src,SC_COMBO, 15, TK_TURNKICK,
 						(2000 - 4*sstatus->agi - 2*sstatus->dex)))
@@ -492,5 +492,5 @@
 						rate += rate*sc->data[SC_SKILLRATE_UP]->val2/100;
 						status_change_end(src,SC_SKILLRATE_UP,-1);
-					} 
+					}
 					sc_start4(src,SC_COMBO, rate, TK_COUNTER, bl->id,0,0,
 						(2000 - 4*sstatus->agi - 2*sstatus->dex));
@@ -662,5 +662,5 @@
 	case NPC_PETRIFYATTACK:
 		sc_start4(bl,status_skill2sc(skillid),50+10*skilllv,
-			skilllv,0,0,skill_get_time(skillid,skilllv), 
+			skilllv,0,0,skill_get_time(skillid,skilllv),
 			skill_get_time2(skillid,skilllv));
 		break;
@@ -680,5 +680,5 @@
 		sc_start(bl,SC_BLEEDING,(20*skilllv),skilllv,skill_get_time2(skillid,skilllv));
 		break;
-	case NPC_MENTALBREAKER: 
+	case NPC_MENTALBREAKER:
 	{	//Based on observations by Tharis, Mental Breaker should do SP damage
 	  	//equal to Matk*skLevel.
@@ -785,5 +785,5 @@
 			if (tsc->data[SC_ADRENALINE2])
 				status_change_end(bl, SC_ADRENALINE2, -1);
-		}		
+		}
 		break;
 	case TK_TURNKICK:
@@ -821,4 +821,35 @@
 		sc_start(bl,SC_CRITICALWOUND,100,skilllv,skill_get_time2(skillid,skilllv));
 		break;
+<<<<<<< .mine
+	case NC_GHOULTOUCH:	//Necro Ghoul Touch [Brain]
+	if (battle_check_living(tstatus->race, tstatus->def_ele)) //Check if target is a living creature before proceed
+		sc_start(bl,SC_POISON,10000,skilllv,skill_get_time2(skillid,skilllv));
+	break;
+	case NC_PWSUFFER:	//Necro Power Word: Suffer [Brain]
+	case WL_PWAGONY:	//Warlock Power Word: Agony [Brain]
+	if (battle_check_living(tstatus->race, tstatus->def_ele)) //Check if target is a living creature before proceed
+		sc_start(bl,skillid==NC_PWSUFFER?SC_SUFFER:SC_AGONY,1000,skilllv,skill_get_time2(skillid,skilllv));
+	break;
+	case WL_SEARING:	//Warlock Searing Pain [Brain]
+	//The DoT is only initiated if target isnt burning already.
+	if(!tsc->data[SC_SEARING] && !tsc->data[SC_IMMOLATE])
+		sc_start(bl,SC_SEARING,10000,skilllv,skill_get_time2(skillid,skilllv));
+	break;
+	case WL_IMMOLATE:	//Warlock Immolate [Brain]
+	//The DoT is only initiated if target isnt in immolate, but must be in searing pain status
+	if(tsc->data[SC_SEARING] && !tsc->data[SC_IMMOLATE])
+		sc_start(bl,SC_IMMOLATE,10000,skilllv,skill_get_time2(skillid,skilllv));
+	break;
+	case WL_SHADOWBURN:	//Warlock Shadow Burn [Brain]
+	sc_start(bl,SC_STUN,10000,skilllv,skill_get_time(skillid,skilllv));
+	break;
+	//Mercenary Skills [Brainstorm]
+/*	case MS_BASH:
+	sc_start(bl,SC_STUN,5*(skilllv-5),skilllv,skill_get_time(skillid,skilllv));
+	break;
+	case MER_CRASH:
+	sc_start(bl,SC_STUN,6*skilllv,skilllv,skill_get_time(skillid,skilllv));
+	break;*/
+=======
 		//Custom Jobs (blackmagic)
 	case NC_GHOULTOUCH:	//Necro Ghoul Touch [Brain]
@@ -845,4 +876,5 @@
 		break;
 //Custom Job End
+>>>>>>> .r18
 	}
 
@@ -956,5 +988,5 @@
 	if(sd && sd->classchange && attack_type&BF_WEAPON &&
 		dstmd && !(tstatus->mode&MD_BOSS) &&
-		(rand()%10000 < sd->classchange)) 
+		(rand()%10000 < sd->classchange))
 	{
 		struct mob_db *mob;
@@ -965,5 +997,5 @@
 				class_ = rand() % MAX_MOB_DB;
 			} while (!mobdb_checkid(class_));
-			
+
 			rate = rand() % 1000000;
 			mob = mob_db(class_);
@@ -979,8 +1011,8 @@
 
 /* Splitted off from skill_additional_effect, which is never called when the
- * attack skill kills the enemy. Place in this function counter status effects 
- * when using skills (eg: Asura's sp regen penalty, or counter-status effects 
+ * attack skill kills the enemy. Place in this function counter status effects
+ * when using skills (eg: Asura's sp regen penalty, or counter-status effects
  * from cards) that will take effect on the source, not the target. [Skotlex]
- * Note: Currently this function only applies to Extremity Fist and BF_WEAPON 
+ * Note: Currently this function only applies to Extremity Fist and BF_WEAPON
  * type of skills, so not every instance of skill_additional_effect needs a call
  * to this one.
@@ -992,5 +1024,5 @@
 	struct map_session_data *dstsd=NULL;
 	struct status_change *tsc;
-	
+
 	nullpo_retr(0, src);
 	nullpo_retr(0, bl);
@@ -1010,5 +1042,5 @@
 		if(tsc && tsc->data[SC_KAAHI] && tsc->data[SC_KAAHI]->val4 == -1)
 			tsc->data[SC_KAAHI]->val4 = add_timer(
-				tick+skill_get_time2(SL_KAAHI,tsc->data[SC_KAAHI]->val1), 
+				tick+skill_get_time2(SL_KAAHI,tsc->data[SC_KAAHI]->val1),
 				kaahi_heal_timer, bl->id, SC_KAAHI); //Activate heal.
 		break;
@@ -1042,4 +1074,16 @@
 		status_heal(src, 0, status_get_lv(bl)*(95+15*rate)/100, 2);
 	}
+<<<<<<< .mine
+
+	// Warlock Soul Steal [Brain]
+	if(sd && skillid && attack_type&BF_MAGIC && status_isdead(bl)
+	&& !(skill_get_inf(skillid)&(INF_GROUND_SKILL|INF_SELF_SKILL))
+	&& (rate=pc_checkskill(sd,WL_SOULSTEAL))>0){// Wont work with area/ground spells (hellfire)
+	if (pc_issit(sd)) pc_setstand(sd);
+	clif_skill_nodamage(src,bl,WL_SOULSTEAL,rate,1);
+	clif_specialeffect(src, 253, AREA); // Absorb Mana effect on caster
+	status_heal(src, 0, status_get_lv(bl)*(90+10*rate)/100, 2);
+	if(rand()%100 < rate) skill_additem(src,src,15020,1); //Chance to "steal" the target soul
+=======
 //Custom Jobs (blackmagic)	
 	// Warlock Soul Steal [Brain]
@@ -1052,6 +1096,7 @@
 		status_heal(src, 0, status_get_lv(bl)*(90+10*rate)/100, 2);
 		if(rand()%100 < rate) skill_additem(src,src,15020,1); //Chance to "steal" the target soul
-	}
-//Custom Job End
+>>>>>>> .r18
+	}
+
 	if(dstsd && attack_type&BF_WEAPON)
 	{	//Counter effects.
@@ -1064,5 +1109,5 @@
 				rate+=dstsd->addeff2[i].arrow_rate;
 			if (!rate) continue;
-			
+
 			if ((dstsd->addeff2[i].flag&(ATF_LONG|ATF_SHORT)) != (ATF_LONG|ATF_SHORT))
 			{	//Trigger has range consideration.
@@ -1073,8 +1118,8 @@
 			type = dstsd->addeff2[i].id;
 			time = skill_get_time2(status_sc2skill(type),7);
-			
+
 			if (dstsd->addeff2[i].flag&ATF_TARGET)
 				status_change_start(src,type,rate,7,0,0,0,time,0);
-			
+
 			if (dstsd->addeff2[i].flag&ATF_SELF && !status_isdead(bl))
 				status_change_start(bl,type,rate,7,0,0,0,time,0);
@@ -1084,5 +1129,5 @@
 	// Trigger counter-spells to retaliate against damage causing skills.
 	if(dstsd && !status_isdead(bl) && src != bl && dstsd->autospell2[0].id &&
-		!(skillid && skill_get_nk(skillid)&NK_NO_DAMAGE)) 
+		!(skillid && skill_get_nk(skillid)&NK_NO_DAMAGE))
 	{
 		struct block_list *tbl;
@@ -1104,5 +1149,5 @@
 			if (attack_type&BF_LONG)
 				 rate>>=1;
-			
+
 			if (skillnotok(skillid, dstsd))
 				continue;
@@ -1113,5 +1158,5 @@
 			else
 				tbl = src;
-			
+
 			switch (skill_get_casttype(skillid)) {
 				case CAST_GROUND:
@@ -1137,5 +1182,5 @@
 	//Auto-script when attacked
 	if(dstsd && !status_isdead(bl) && src != bl && dstsd->autoscript2[0].script &&
-		!(skillid && skill_get_nk(skillid)&NK_NO_DAMAGE)) 
+		!(skillid && skill_get_nk(skillid)&NK_NO_DAMAGE))
 	{
 		int i;
@@ -1161,5 +1206,5 @@
    (BCT_ENEMY/BCT_PARTY/BCT_SELF) are the valid values.
 --------------------------------------------------------------------------*/
-int skill_break_equip (struct block_list *bl, unsigned short where, int rate, int flag) 
+int skill_break_equip (struct block_list *bl, unsigned short where, int rate, int flag)
 {
 	const int where_list[4]     = {EQP_WEAPON, EQP_ARMOR, EQP_SHIELD, EQP_HELM};
@@ -1263,5 +1308,5 @@
 	for (i = 0; i < ARRAYLENGTH(pos); i++) {
 		if (where&pos[i] && sc->data[sc_def[i]])
-			where&=~pos[i]; 
+			where&=~pos[i];
 	}
 	if (!where) return 0;
@@ -1293,5 +1338,5 @@
 	if (count == 0)
 		return 0; //Actual knockback distance is 0.
-	
+
 	switch (target->type)
 	{
@@ -1328,5 +1373,5 @@
 
 	if (!su)
-		unit_stop_walking(target,0); 
+		unit_stop_walking(target,0);
 
 	dx = nx - target->x;
@@ -1345,5 +1390,5 @@
 	map_foreachinmovearea(clif_insight, target, AREA_SIZE, -dx, -dy, target->type == BL_PC ? BL_ALL : BL_PC, target);
 
-	if(!(flag&0x1)) 
+	if(!(flag&0x1))
 		clif_blown(target);
 
@@ -1393,5 +1438,5 @@
  * flag&0xFFF is passed to the underlying battle_calc_attack for processing
  *      (usually holds number of targets, or just 1 for simple splash attacks)
- * flag&0x1000 is used to tag that this is a splash-attack (so the damage 
+ * flag&0x1000 is used to tag that this is a splash-attack (so the damage
  *      packet shouldn't display a skill animation)
  * flag&0x2000 is used to signal that the skilllv should be passed as -1 to the
@@ -1494,5 +1539,5 @@
 			}
 		}
-	
+
 		if(sc && sc->data[SC_MAGICROD] && src == dsrc) {
 			int sp = skill_get_sp(skillid,skilllv);
@@ -1508,8 +1553,7 @@
 
 	damage = dmg.damage + dmg.damage2;
-	
-	if (skillid == AL_INCAGI || skillid == AL_BLESSING)
-		if (tsd->sc.data[SC_CHANGEUNDEAD])
-			damage = 1;
+
+	if( (skillid == AL_INCAGI || skillid == AL_BLESSING) && tsd->sc.data[SC_CHANGEUNDEAD] )
+		damage = 1;
 
 	if (damage > 0 && dmg.flag&BF_WEAPON && src != bl && src == dsrc &&
@@ -1520,5 +1564,5 @@
 	type=(skillid==0)?5:skill_get_hit(skillid);
 
-	if(damage < dmg.div_ 
+	if(damage < dmg.div_
 		//Only skills that knockback even when they miss. [Skotlex]
 		&& skillid != CH_PALMSTRIKE)
@@ -1649,5 +1693,5 @@
 		break;
 	}
-	
+
 	map_freeblock_lock();
 
@@ -1682,6 +1726,6 @@
 		}
 	}
-	if (skillid != WZ_SIGHTRASHER && 
-		skillid != WZ_SIGHTBLASTER && 
+	if (skillid != WZ_SIGHTRASHER &&
+		skillid != WZ_SIGHTBLASTER &&
 		skillid != AC_SHOWER &&
 		skillid != SM_MAGNUM &&
@@ -1705,5 +1749,5 @@
 			if (!status_isdead(bl))
 				skill_additional_effect(src,bl,skillid,skilllv,attack_type,tick);
-			//Counter status effects [Skotlex] 
+			//Counter status effects [Skotlex]
 			skill_counter_additional_effect(dsrc,bl,skillid,skilllv,attack_type,tick);
 		}
@@ -1723,5 +1767,5 @@
 		skill_blown(dsrc,bl,dmg.blewcount,direction,0);
 	}
-	
+
 	//Delayed damage must be dealt after the knockback (it needs to know actual position of target)
 	if (dmg.amotion)
@@ -1755,5 +1799,5 @@
 
 	if (!(flag&2) &&
-		(	
+		(
 			skillid == MG_COLDBOLT || skillid == MG_FIREBOLT || skillid == MG_LIGHTNINGBOLT
 		) &&
@@ -1800,9 +1844,11 @@
 	if(battle_check_target(src,bl,flag) > 0)
 	{
-		if (flag&(SD_SPLASH|SD_PREAMBLE)) {
-			if (flag&SD_PREAMBLE && !skill_area_temp[2])
-				clif_skill_damage(src,bl,tick, status_get_amotion(src), 0, -30000, 1, skill_id, skill_lv, 6);
+		// several splash skills need this initial dummy packet to display correctly
+		if (flag&SD_PREAMBLE && skill_area_temp[2] == 0)
+			clif_skill_damage(src,bl,tick, status_get_amotion(src), 0, -30000, 1, skill_id, skill_lv, 6);
+
+		if (flag&(SD_SPLASH|SD_PREAMBLE))
 			skill_area_temp[2]++;
-		}
+
 		return func(src,bl,skill_id,skill_lv,tick,flag);
 	}
@@ -1927,5 +1973,5 @@
 	struct map_session_data *sd;
 	int gid, id, strvit, agidex;
-	
+
 	sd = (struct map_session_data *)bl;
 
@@ -1967,5 +2013,5 @@
 	int i,j,hp,sp,hp_rate,sp_rate,state,mhp ;
 	int itemid[10],amount[ARRAYLENGTH(itemid)],index[ARRAYLENGTH(itemid)];
-	
+
 	nullpo_retr(0, hd);
 	sd = hd->master;
@@ -2102,5 +2148,5 @@
 				target = src; //Required since it has to warp.
 			if(target == NULL)
-				break;	
+				break;
 			if(target->prev == NULL)
 				break;
@@ -2145,4 +2191,40 @@
 					}
 					break;
+<<<<<<< .mine
+
+		case NC_PWSUFFER: //Necro Power Word: Suffer [Brain]
+			if (!status_isdead(target) && status_get_sc(target)->data[SC_SUFFER]){
+			skill_attack(BF_MAGIC,src,src,target,skl->skill_id,skl->skill_lv,tick,skl->flag|SD_ANIMATION|SD_LEVEL);
+			clif_specialeffect(target, 180, AREA); //Shadow Hit Effect on target
+			if (skl->type>1 && !status_isdead(target))
+				skill_addtimerskill(src,tick+3000,target->id,0,0,skl->skill_id,skl->skill_lv,skl->type-1,skl->flag|SD_ANIMATION);
+			}
+			break;
+		case WL_SEARING: //Warlock Searing Pain [Brain]
+			if (!status_isdead(target) && status_get_sc(target)->data[SC_SEARING]){
+			skill_attack(BF_MAGIC,src,target,target,skl->skill_id,skl->skill_lv,tick,skl->flag|SD_ANIMATION|SD_LEVEL);
+			clif_specialeffect(target, 49, AREA); //Fire Hit Effect on target
+			if (skl->type>1 && !status_isdead(target))
+				skill_addtimerskill(src,tick+3000,target->id,0,0,skl->skill_id,skl->skill_lv,skl->type-1,skl->flag|SD_ANIMATION);
+			}
+			break;
+		case WL_IMMOLATE: //Warlock Immolate [Brain]
+			if (!status_isdead(target) && status_get_sc(target)->data[SC_IMMOLATE]){
+			skill_attack(BF_MAGIC,src,target,target,skl->skill_id,skl->skill_lv,tick,skl->flag|SD_ANIMATION|SD_LEVEL);
+			clif_specialeffect(target, 97, AREA); //Firepillar Hit Effect on target
+			if (skl->type>1 && !status_isdead(target))
+				skill_addtimerskill(src,tick+3000,target->id,0,0,skl->skill_id,skl->skill_lv,skl->type-1,skl->flag|SD_ANIMATION);
+			}
+			break;
+		case WL_PWAGONY: //Warlock Power Word: Agony [Brain]
+			if (!status_isdead(target) && status_get_sc(target)->data[SC_AGONY]){
+			skill_attack(BF_MAGIC,src,target,target,skl->skill_id,skl->skill_lv,tick,skl->flag|SD_ANIMATION|SD_LEVEL);
+			clif_specialeffect(target, 587, AREA); //Big Purple Flame Effect on target
+			if (skl->type>1 && !status_isdead(target))
+				skill_addtimerskill(src,tick+3000,target->id,0,0,skl->skill_id,skl->skill_lv,skl->type-1,skl->flag|SD_ANIMATION);
+			}
+			break;
+
+=======
 					//Custom Jobs (blackmagic)
 				
@@ -2181,4 +2263,5 @@
 				
 					//Custom Job End
+>>>>>>> .r18
 				default:
 					skill_attack(skl->type,src,src,target,skl->skill_id,skl->skill_lv,tick,skl->flag);
@@ -2216,8 +2299,8 @@
 	ud = unit_bl2ud(src);
 	nullpo_retr(1, ud);
-	
+
 	ARR_FIND( 0, MAX_SKILLTIMERSKILL, i, ud->skilltimerskill[i] == 0 );
 	if( i == MAX_SKILLTIMERSKILL ) return 1;
-	
+
 	ud->skilltimerskill[i] = ers_alloc(skill_timer_ers, struct skill_timerskill);
 	ud->skilltimerskill[i]->timer = add_timer(tick, skill_timerskill, src->id, i);
@@ -2244,5 +2327,5 @@
 	ud = unit_bl2ud(src);
 	nullpo_retr(0, ud);
-		
+
 	for(i=0;i<MAX_SKILLTIMERSKILL;i++) {
 		if(ud->skilltimerskill[i]) {
@@ -2281,5 +2364,5 @@
 
 	nullpo_retr(1, src);
-	nullpo_retr(1, bl);	
+	nullpo_retr(1, bl);
 
 	if (src->m != bl->m)
@@ -2288,5 +2371,5 @@
 	if (bl->prev == NULL)
 		return 1;
-	
+
 	sd = BL_CAST(BL_PC, src);
 	tsd = BL_CAST(BL_PC, bl);
@@ -2304,5 +2387,5 @@
 	}
 
-	sc = status_get_sc(src);	
+	sc = status_get_sc(src);
 	if (sc && !sc->count)
 		sc = NULL; //Unneeded
@@ -2393,5 +2476,31 @@
 	case NPC_BLEEDING:
 	case NPC_CRITICALWOUND:
+	/*Mercenary Skills [Brainstorm]
+	case MS_BASH:
+	case MA_DOUBLE:
+	case MA_CHARGEARROW:
+	case ML_PIERCE:
+	case ML_SPIRALPIERCE:
+	case MER_CRASH:
 		skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
+<<<<<<< .mine
+		break;*/
+	case NC_GHOULTOUCH:	//Necro Ghoul Touch [Brain]
+	skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
+	clif_specialeffect(bl, 124, AREA); //Venom Dust Effect on target
+	break;
+	case NC_DEATHHAND:	 //Necro Death Hand [Brain]
+	skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag|SD_LEVEL);//Hide skill yell
+	clif_specialeffect(bl, 65, AREA); //Power absorb Effect on target
+	if (battle_check_living(tstatus->race, tstatus->def_ele)){ //Check if target is a living creature before proceed
+		int chance = (10+(skilllv*2)+(status_get_luk(src)-status_get_luk(bl))/5);
+		//10% chance + 2% per skilllv + (caster luk - target luk)/5 %
+		if (rand()%100 < chance) {
+			clif_skill_nodamage(src,bl,skillid,-1,flag|SD_LEVEL);//Hide skill yell
+			status_percent_damage(src, bl, 100, 0, true); //Instant kill our target
+		} else clif_skill_fail(sd,skillid,0,0);
+	}
+	break;
+=======
 		break;
 		//Custom Jobs (blackmagic)
@@ -2414,4 +2523,6 @@
 		break;
 		//Custom Job End
+>>>>>>> .r18
+
 
 	case LK_JOINTBEAT: // decide the ailment first (affects attack damage and effect)
@@ -2446,5 +2557,5 @@
 		map_foreachinrange(skill_attack_area, src,
 			skill_get_splash(skillid, skilllv), splash_target(src),
-			BF_WEAPON, src, src, skillid, skilllv, tick, flag, BCT_ENEMY);	
+			BF_WEAPON, src, src, skillid, skilllv, tick, flag, BCT_ENEMY);
 		break;
 
@@ -2588,5 +2699,5 @@
 	//Splash attack skills.
 	case AS_GRIMTOOTH:
-	case MC_CARTREVOLUTION:	
+	case MC_CARTREVOLUTION:
 	case NPC_SPLASHATTACK:
 		flag |= SD_PREAMBLE; // a fake packet will be sent for the first target to be hit
@@ -2594,5 +2705,5 @@
 	case SM_MAGNUM:
 	case HT_BLITZBEAT:
-	case AC_SHOWER:	
+	case AC_SHOWER:
 	case MG_NAPALMBEAT:
 	case MG_FIREBALL:
@@ -2651,5 +2762,5 @@
 		if (skill_area_temp[1] != bl->id)
 			skill_attack(skill_get_type(skillid), src, src, bl, skillid, skilllv, tick, flag|SD_ANIMATION);
-		else 
+		else
 			skill_attack(skill_get_type(skillid), src, src, bl, skillid, skilllv, tick, flag);
 		break;
@@ -2716,10 +2827,10 @@
 				skill_castend_nodamage_id);
 	}
-		break;	
+		break;
 	case CH_PALMSTRIKE: //	Palm Strike takes effect 1sec after casting. [Skotlex]
 	//	clif_skill_nodamage(src,bl,skillid,skilllv,0); //Can't make this one display the correct attack animation delay :/
 		clif_damage(src,bl,tick,status_get_amotion(src),0,-1,1,4,0); //Display an absorbed damage attack.
 		skill_addtimerskill(src, tick + 1000, bl->id, 0, 0, skillid, skilllv, BF_WEAPON, flag);
-		break;	
+		break;
 
 	case PR_TURNUNDEAD:
@@ -2749,6 +2860,87 @@
 		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
 		break;
+<<<<<<< .mine
+	case AD_DARKHEAL: // Adept Dark Heal [Brain]
+	clif_specialeffect(bl, 656, AREA); //Blinking Green Sprite Effect on target
+	skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag); //Exception because we must add the effect manually =/
+	break;
+	case NC_PWSUFFER: //Necro Power Word: Suffer [Brain]
+	if(battle_check_living(tstatus->race,tstatus->def_ele)){
+		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+		clif_specialeffect(bl, 180, AREA); //Shadow hit Effect on target
+		clif_specialeffect(src, 454, AREA); //Black Cast Effect on caster
+		//If target is on suffering status already, just cause damage, no extra DoT
+		if(!status_get_sc(bl)->data[SC_SUFFER])
+		skill_addtimerskill(src,tick+3000,bl->id,0,0,skillid,skilllv,skilllv,flag);
+	}
+	else clif_skill_fail(sd,skillid,0,0);
+	break;
+	case NC_DRAINLIFE: // Necromancer Drain Life [Brain]
+	{
+		int heal = skill_attack(BF_MAGIC, src, src, bl, skillid, skilllv, tick, flag)/2;
+		if (heal > 0 && (battle_check_living(tstatus->race,tstatus->def_ele))){
+		clif_skill_nodamage(NULL, src, AL_HEAL, heal, 1);
+		status_heal(src, heal, 0, 0);
+		}
+	}
+	clif_specialeffect(bl, 180, AREA); //Shadow hit Effect on target
+	clif_specialeffect(src, 454, AREA); //Black Cast Effect on caster
+	break;
+	case WL_SHADOWBOLT: // Warlock Shadowbolt [Brain]
+	clif_specialeffect(bl, 180, AREA); //Shadow hit Effect on target
+	clif_specialeffect(src, 454, AREA); //Black Cast Effect on caster
+	skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag); //Again, the effect...cursed effects...
+	break;
+	case WL_SHADOWBURN: // Warlock Shadow Burn [Brain]
+	clif_specialeffect(bl, 180, AREA); //Shadow hit Effect on target
+	clif_specialeffect(bl, 32, AREA); //Flame Engulf Effect on target
+	clif_specialeffect(src, 454, AREA); //Black Cast Effect on caster
+	skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+	break;
+	case WL_SEARING: // Warlock Searing Pain [Brain]
+	clif_specialeffect(bl, 406, AREA); //Fire on Head Effect on target
+	clif_specialeffect(src, 55, AREA); //Red Cast Effect on caster
+	skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+	//if target is on searing status already, just cause damage, no extra DoT
+	if(!status_get_sc(bl)->data[SC_SEARING])
+		skill_addtimerskill(src,tick+3000,bl->id,0,0,skillid,skilllv,4,flag);
+	break;
+	case WL_CONFLAGRATE: // Warlock Conflagrate [Brain]
+	if(status_get_sc(bl)->data[SC_IMMOLATE]) { // Can only be casted if target is immolating status
+		clif_specialeffect(bl, 183, AREA); //Explosion Effect on target
+		clif_specialeffect(src, 55, AREA); //Red Cast Effect on caster
+		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+		status_change_end(bl,SC_IMMOLATE,-1); //End Immolating status
+	} else clif_skill_fail(sd,skillid,0,0);
+	break;
+	case WL_IMMOLATE: // Warlock Immolate [Brain]
+	clif_specialeffect(bl, 635, AREA); //Dragon Fire Effect on target
+	clif_specialeffect(src, 55, AREA); //Red Cast Effect on caster
+	skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+	//If Target is on searing pain status, will change immolating status instead
+	if(!status_get_sc(bl)->data[SC_IMMOLATE])
+		skill_addtimerskill(src,tick+3000,bl->id,0,0,skillid,skilllv,5,flag);
+	break;
+	case WL_CURSEDOOM: // Warlock Curse of Doom [Brain]
+	clif_specialeffect(bl, 183, AREA); //Explosion Effect on target
+	skill_attack(BF_MAGIC,src,bl,bl,skillid,skilllv,tick,flag|SD_ANIMATION);
+	break;
+	case WL_PWAGONY: // Warlock Power Word: Agony [Brain]
+	if(battle_check_living(tstatus->race,tstatus->def_ele)){
+		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
+		clif_specialeffect(bl, 587, AREA); //Big Purple Flame Effect on target
+		clif_specialeffect(src, 454, AREA); //Black Cast Effect on caster
+		//If target is on Agonizing status already, just cause damage, no extra DoT
+		if(!status_get_sc(bl)->data[SC_AGONY])
+		skill_addtimerskill(src,tick+3000,bl->id,0,0,skillid,skilllv,skilllv,flag);
+	}
+	else clif_skill_fail(sd,skillid,0,0);
+	break;
+=======
 		//Custom Jobs (blackmagic)
-
+>>>>>>> .r18
+
+<<<<<<< .mine
+=======
 	
 	case AD_DARKHEAL: // Adept Dark Heal [Brain]
@@ -2830,4 +3022,5 @@
 
 		//Custom Job End
+>>>>>>> .r18
 
 	case NPC_MAGICALATTACK:
@@ -2867,5 +3060,5 @@
 					count++; // natural water cell
 				else
-				if( (unit = map_find_skill_unit_oncell(src,x,y,SA_DELUGE,NULL)) != NULL 
+				if( (unit = map_find_skill_unit_oncell(src,x,y,SA_DELUGE,NULL)) != NULL
 				||  (unit = map_find_skill_unit_oncell(src,x,y,NJ_SUITON,NULL)) != NULL )
 				{
@@ -2932,5 +3125,5 @@
 				skill_attack(BF_MAGIC,src,src,src,skillid,skilllv,tick,flag);
 			status_percent_damage(src, src, 0, 100, false);
-		}		
+		}
 		if (sd) skill_blockpc_start (sd, skillid, (skilllv < 5 ? 10000: 15000));
 		break;
@@ -2993,5 +3186,5 @@
 	}
 
-	map_freeblock_unlock();	
+	map_freeblock_unlock();
 
 	if (sd && !(flag&1) && sd->state.arrow_atk) //Consume arrow on last invocation to this skill.
@@ -3001,5 +3194,5 @@
 
 /*==========================================
- * 
+ *
  *------------------------------------------*/
 int skill_castend_nodamage_id (struct block_list *src, struct block_list *bl, int skillid, int skilllv, unsigned int tick, int flag)
@@ -3015,5 +3208,5 @@
 	int i;
 	enum sc_type type;
-	
+
 	if(skillid > 0 && skilllv <= 0) return 0;	// celest
 
@@ -3035,14 +3228,18 @@
 	if(status_isdead(src))
 		return 1;
+<<<<<<< .mine
+
+=======
 //Custom Jobs (blackmagic)
 	/*if(src!=bl && status_isdead(bl) && skillid != ALL_RESURRECTION && skillid != PR_REDEMPTIO)*/
 	// Added DEATHPACT [Brain]
 	//if(src!=bl && status_isdead(bl) && skillid != ALL_RESURRECTION && skillid != PR_REDEMPTIO)
+>>>>>>> .r18
 	if(src!=bl && status_isdead(bl) && skillid != ALL_RESURRECTION && skillid != PR_REDEMPTIO && skillid != NC_DEATHPACT)
 		return 1;
-//Custom Job End
+
 	tstatus = status_get_status_data(bl);
 	sstatus = status_get_status_data(src);
-	
+
 	//Check for undead skills that convert a no-damage skill into a damage one. [Skotlex]
 	switch (skillid) {
@@ -3065,4 +3262,20 @@
 			}
 			break;
+<<<<<<< .mine
+	case AD_DARKHEAL:	// Adept Dark Heal [Brain]
+		// Only player casted spells can be offensive (copyed from AL_HEAL code above)
+		if (sd && (battle_check_living(tstatus->race,tstatus->def_ele)) //Check if target is a living creature
+		&& !pc_checkskill(dstsd,NC_PHYLACTERY) //Or he doesnt have Phylactery (non-perma undead)
+		&& !status_get_sc(bl)->data[SC_OVERWHELMING]) { //Or Overwhelming Evil is off (most cases)
+		if (battle_check_target(src, bl, BCT_ENEMY) < 1) {
+			  //Offensive heal does not works on non-enemies.
+			clif_skill_fail(sd,skillid,0,0);
+			return 0;
+		}
+		return skill_castend_damage_id(src, bl, skillid, skilllv, tick, flag);
+		}
+		break;
+
+=======
 			//Custom Jobs (blackmagic)
 		
@@ -3082,4 +3295,5 @@
 		
 			//Custom Job End
+>>>>>>> .r18
 		case NPC_SMOKING: //Since it is a self skill, this one ends here rather than in damage_id. [Skotlex]
 			return skill_castend_damage_id (src, bl, skillid, skilllv, tick, flag);
@@ -3108,7 +3322,15 @@
 			int heal = skill_calc_heal(src, bl, skilllv);
 			int heal_get_jobexp;
-	
+
 			if (status_isimmune(bl) || (dstmd && dstmd->class_ == MOBID_EMPERIUM))
 				heal=0;
+<<<<<<< .mine
+		// Profane Soul reduces the healed recieved by 3% per skilllv [Brain]
+		if(dstsd) {
+		heal = heal * (100 - pc_checkskill(dstsd,AD_PROFANE)*3)/100;
+		//Wont heal even if he got elemental armors [Brain]
+		if(pc_checkskill(dstsd,NC_PHYLACTERY)) heal = skilllv;
+		}
+=======
 			//Custom Jobs (blackmagic)
 			// Profane Soul reduces the healed recieved by 3% per skilllv [Brain]
@@ -3119,4 +3341,5 @@
 			}
 			//Custom Job End
+>>>>>>> .r18
 			if (sd) {
 				if ((i = pc_skillheal_bonus(sd, skillid)))
@@ -3154,4 +3377,27 @@
 		}
 		break;
+<<<<<<< .mine
+
+	case AD_DARKHEAL: // Adept Dark Heal [Brain]
+	{
+		int heal = skill_calc_heal(src, bl, skilllv);
+		if (status_isimmune(bl) || (dstmd && dstmd->class_ == MOBID_EMPERIUM))
+		heal=0;
+		if(battle_check_undead(tstatus->race,tstatus->def_ele) || tstatus->race==RC_UNDEAD // Check if our target is undead or demon
+		|| tstatus->race==RC_DEMON || pc_checkskill(dstsd,NC_PHYLACTERY)//Or has a phylactery
+		|| status_get_sc(bl)->data[SC_OVERWHELMING]) { //Or is on OverWhelm status, checking again...
+		clif_skill_nodamage(src, bl, skillid, heal, 1);
+		clif_skill_nodamage(NULL, bl, AL_HEAL, heal, 1); //Subtle way to show heal numbers AND effect =D
+		status_heal(bl, heal, 0, 0);
+		} else {
+		clif_skill_nodamage(src, bl, skillid, 0, 1);
+		clif_skill_nodamage(NULL, bl, AL_HEAL, 0, 1);
+		}
+	clif_specialeffect(bl, 656, AREA); //Blinking Green Sprite Effect on target
+	}
+	break;
+
+
+=======
 	//Custom Jobs (blackmagic)
 	
@@ -3175,4 +3421,5 @@
 		break;
 	//Custom Job End
+>>>>>>> .r18
 	case PR_REDEMPTIO:
 		if (sd && !(flag&1)) {
@@ -3205,9 +3452,7 @@
 		} else //Invalid target, skip resurrection.
 			break;
-		
+
 	case ALL_RESURRECTION:
-	//Custom Jobs (blackmagic)
 	case NC_DEATHPACT: // Necro Death Pact [Brain]
-	//Custom Job End
 		if(sd && map_flag_gvg(bl->m))
 		{	//No reviving in WoE grounds!
@@ -3217,5 +3462,5 @@
 		if (!status_isdead(bl))
 			break;
-		{	
+		{
 			int per = 0, sper = 0;
 			if (map[bl->m].flag.pvp && dstsd && dstsd->pvp_point < 0)
@@ -3227,13 +3472,20 @@
 			case 3: per=50; break;
 			case 4: per=80; break;
-			//Custom Jobs (blackmagic)
 			case 5: per=100; break; //Added a 5th level because NC_DEATHPACT got 5 lvs [Brain]
-			//Custom Job End
-			}
-			if(dstsd && dstsd->special_state.restart_full_recover) 
+			}
+			if(dstsd && dstsd->special_state.restart_full_recover)
 				per = sper = 100;
 			if (status_revive(bl, per, sper))
 			{
 				clif_skill_nodamage(src,bl,ALL_RESURRECTION,skilllv,1); //Both Redemptio and Res show this skill-animation.
+<<<<<<< .mine
+						if(skillid==NC_DEATHPACT) { // Necro Death Pact [Brain]
+			clif_skill_nodamage(src, bl, skillid, skilllv,
+			sc_start(bl,type,100,skilllv,skill_get_time(skillid,skilllv)));
+			break;
+		}
+
+				if(sd && dstsd && battle_config.resurrection_exp > 0)
+=======
 				//Custom Jobs (blackmagic)
 				if(skillid==NC_DEATHPACT) { // Necro Death Pact [Brain]
@@ -3244,4 +3496,5 @@
 				//Custom Job End
 				if(sd && dstsd && battle_config.resurrection_exp > 0) 
+>>>>>>> .r18
 				{
 					int exp = 0,jexp = 0;
@@ -3261,4 +3514,6 @@
 		}
 		break;
+<<<<<<< .mine
+=======
 		//Custom Jobs (blackmagic)
 	
